Subject: bug#44723: Latest binary tarball & Hurd qcow2 image unavailable (502)

From: Ludovic Courtès <[email-masked]>
Date: Wed, 18 Nov 2020 18:45:01 +0100

Hi,

Tobias Geerinckx-Rice via Bug reports for GNU Guix <[email-masked]>
skribis:

> The binary tarball and Hurd qcow2 links on
> <http://guix.gnu.org/en/download/latest/>, which resolve to 
> <https://ci.guix.gnu.org/download/1385> and
> <https://ci.guix.gnu.org/download/1450> respectively, return 502.
>
> Here's why:
>
>  2020-11-18T17:31:24 GET /download/1450
>  Uncaught exception in fiber ##f:
>  In ice-9/boot-9.scm:
>    1669:16  0 (raise-exception _ #:continuable? _)
>  ice-9/boot-9.scm:1669:16: In procedure raise-exception:
>  In procedure open-file: No such file or directory:
>  "/gnu/store/vd5y7hmvgqc1hwmqyiwqa171r0iz1wib-hurd-barebones.qcow2"
>
> The file really is gone.  It seems that Cuirass is no longer creating
> sufficient GC roots.  I vaguely remember some changes to image GC'ing
> being discussed but not what (if anything) changed.

QCOW2 images get GC’d rather quickly, because they take up a lot of
space; see in particular:

  https://git.savannah.gnu.org/cgit/guix/maintenance.git/commit/?id=4a720a03f9d190f7b1abc883f49d51a95a5f58a9
  https://git.savannah.gnu.org/cgit/guix/maintenance.git/commit/?id=0bf8202de811364ebd79e390fcd039f7936b6ea7

I guess it’s OK for Guix System ISO images because a fresh one gets
built at each evaluation, roughly, but perhaps the Hurd images are not
rebuilt frequently enough and the changes that they’re GC’d are higher.

I don’t have a good solution for that, we’re consuming storage space too
quickly with all these images currently.  :-/

Thanks,
Ludo’.